/* $Id: changemgmt.js,v 1.8 2009/09/18 09:19:57 prabhat Exp $ */
function showHidechngMgmt(elementId,status)
{
    var obj = findObjectsById(elementId);

    if(status == true)
    {
	obj.className = '';
    }
    else if(status == false)
    {
	obj.className = 'hide';
    }

}


function getSelectedRules(form,viewName)
{
   var tblModel = getTableModel(viewName);
   if(!tblModel.isAtleastOneChecked("Select atleast a single rule to associate"))
   {
   	return false;
   }
   
   var selIndices = tblModel.getSelectedRowIndices();
   var colInd = tblModel.getColumnIndex("RULE_ID");
   
   var pkValueStr = "";
   for(var i=0;i<selIndices.length;i++)
   {
      pkValueStr = pkValueStr + "&" + "RULE_ID" + "=" + tblModel.getValueAt(selIndices[i],colInd);
   }
   
   form.action = getURLSuffixed(form.action) + pkValueStr;
   return true;
      
}


function checkIfDGRule(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    var tblModel = getTableModel(srcViewRefId);

    var resourceId = tblModel.getValueAt(index,tblModel.getColumnIndex("RESOURCEID"));
    if(resourceId == null)
    {
	var ruleName = tblModel.getValueAt(index,tblModel.getColumnIndex("RULE_NAME"));    
        alert(I18N.getMsg("js.changemgmt.checkIfDGRule.alert1") + ruleName +I18N.getMsg("js.changemgmt.checkIfDGRule.alert2") );
        return;
    }
    
    if(!menuItemObj.confirmAction())
    {
        return;
    }

    menuItemObj.invokeActionURL(menuItemObj.getActionURL(srcViewRefId,additionalParams,index));
    
}

function stateChange(rowId,expandedImgId,collapsedImgId)
{
   var obj = MM_findObj(rowId);
   var collapsedImage = document.getElementById(collapsedImgId);
   var expandedImage = document.getElementById(expandedImgId);	 
   
   if(obj.className == "hide")
   {
      obj.className = '';
      collapsedImage.className = 'hide';
      expandedImage.className = '';
   }
   else
   {
      obj.className = 'hide';
      collapsedImage.className = '';
      expandedImage.className = 'hide';
   }
}

function validateRuleSettings(form,ruleNames)
{
    var ruleNameEle = document.getElementById("RULE_NAME");
    // only for add rule
    if(ruleNameEle != null)
    {
    	var ruleName = ruleNameEle.value;
    	var len = ruleNames.length;
    	for(i=0;i<len;i++)
    	{
    	  if(ruleName == ruleNames[i])
    	  {
    	    alert(I18N.getMsg("js.changemgmt.validateRuleSettings.alert.1"));
    	    return false;
    	  }
    	}
    }
    
   // checking if condition is selected
   var conditionSelected = false;
   var len = form.CONDITION.length;
   for(i=0;i<len;i++)
   {
   	if(form.CONDITION[i].checked)
   	{
           conditionSelected = true;
           break;
   	}
   }

   if(!conditionSelected)
   {
      alert(I18N.getMsg("js.changemgmt.validateRuleSettings.alert.2"));
      return false;
   }
   
   // checking if atleast a single action is selected
   var sendEmail = document.getElementById("SEND_EMAIL").checked;
   var sendTrap = document.getElementById("SEND_TRAP").checked;
   var generateTicket = document.getElementById("GENERATE_TICKET").checked;
   var rollbackConfig = document.getElementById("ROLLBACK_CONFIG").checked;
   
   if(!sendEmail && !sendTrap && !generateTicket && !rollbackConfig)
   {
      alert(I18N.getMsg("js.changemgmt.validateRuleSettings.alert.3"));
      return false;
   }
   
   // validating individual action values   
   if(sendEmail)
   {
      if(checkEmailSettings() == false)
      {
      	return false;
      }
   }
   
   if(sendTrap)
   {
      if(checkTrapSettings() == false)
      {
      	return false;
      }
   }
   
   if(generateTicket)
   {
      if(checkTicketSettings() == false)
      {
      	return false;
      }   
   }
   
   if(rollbackConfig)
   {
     if(!(form.ROLLBACK_CONFIG_TYPE[0].checked || form.ROLLBACK_CONFIG_TYPE[1].checked))
     {
     	alert(I18N.getMsg("js.changemgmt.validateRuleSettings.alert.4"));
     	return false;
     }
   }

   return true;
}

function checkTrapSettings()
{
   var host = document.getElementById("HOST").value;
   host = trimAll(host);
   if(!isNotEmpty(host))
   {
     alert(I18N.getMsg("js.changemgmt.checkTrapSettings.alert.1"));
     return false;
   }

   var value = document.getElementById("PORT").value;
   value = trimAll(value);
   if(isNotEmpty(value))
   {
    if(!isContainOnlyNumericValues(document.getElementById("PORT"),"Destination Port"))
    {
       return false;
    }
   }
   else
   {
     alert(I18N.getMsg("js.changemgmt.checkTrapSettings.alert.2"));
     return false;
   }
   
   var comm = document.getElementById("COMMUNITY").value;
   comm = trimAll(comm);
   if(!isNotEmpty(comm))
   {
     alert(I18N.getMsg("js.changemgmt.checkTrapSettings.alert.3"));
     return false;
   }
   
   return true;

}

function checkEmailSettings()
{
  var toAddress = document.getElementById("TO_ADDRESS").value;
  var status = true;
  if(!isNotEmpty(toAddress))
  {
    alert(I18N.getMsg("js.changemgmt.checkEmailSettings.alert.1"));
    return false;
  }  
  
  var toAddrArray = toAddress.split(",");
  var len = toAddrArray.length;
  for(i=0;i<len;i++)
  {
    if(!validate(trim(toAddrArray[i])))
    {
            alert(I18N.getMsg("js.validate.checkEmailAddress.variable.1") + " " + toAddrArray[i] + " " + I18N.getMsg("js.validate.checkEmailAddress.variable.2"));
            status= false;
            break;
    }
}
        if(!status)
        {
             return false;
        }
  
  var emailSubject = document.getElementById("EMAIL_SUBJECT").value;
  emailSubject = trimAll(emailSubject);
  if(!isNotEmpty(emailSubject))
  {
    alert(I18N.getMsg("js.changemgmt.checkEmailSettings.alert.2"));
    return false;
  }
  
  var emailMessage = document.getElementById("EMAIL_MESSAGE").value;
  emailMessage = trimAll(emailMessage);
  if(!isNotEmpty(emailMessage))
  {
    alert(I18N.getMsg("js.changemgmt.checkEmailSettings.alert.3"));
    return false;
  }
  
  return true;
   
}

function checkTicketSettings()
{
  var toAddress = document.getElementById("TICKET_TO_ADDRESS").value;
  toAddress = trimAll(toAddress);
  if(!isNotEmpty(toAddress))
  {
    alert(I18N.getMsg("js.changemgmt.checkTicketSettings.alert.1"));
    return false;
  }  
  
  var toAddrArray = toAddress.split(",");
  var len = toAddrArray.length;
  for(i=0;i<len;i++)
  {
     if(!checkEmailAddress(toAddrArray[i]))
     {
       return false;
     }
  }
  
  var ticketSubject = document.getElementById("TICKET_SUBJECT").value;
  ticketSubject = trimAll(ticketSubject);
  if(!isNotEmpty(ticketSubject))
  {
    alert(I18N.getMsg("js.changemgmt.checkTicketSettings.alert.2"));
    return false;
  }
  
  var ticketMessage = document.getElementById("TICKET_MESSAGE").value;
  ticketMessage = trimAll(ticketMessage);
  if(!isNotEmpty(ticketMessage))
  {
    alert(I18N.getMsg("js.changemgmt.checkTicketSettings.alert.3"));
    return false;
  }
  
  return true;
   
}
