/* $Id: diffview.js,v 1.15 2009/08/05 07:51:00 vasus Exp $ */
// diff screen specific scripts

function handleScroll(sourceId, destId)
{
var scrollLockCheckBox = document.getElementById('scrolllockcheckbox');
if(!scrollLockCheckBox.checked)
{
return;
}
var source = document.getElementById(sourceId);
var dest = document.getElementById(destId);
dest.scrollTop=source.scrollTop;
dest.scrollLeft=source.scrollLeft;
}

function showDiffContents(selectobj)
{
    var value = selectobj.options[selectobj.selectedIndex].value;
    if(value == 'SHOW_ALL')
    {
        document.getElementById('SHOW_ALL_DISPLAY').className="";
        document.getElementById('SHOW_DIFF_ALONE_DISPLAY').className="hide";

        current_diff_index = parseInt(current_diff_index);
        if(diff_array.length == 0 || (diff_array.length == 1 && isAlreadyViewed))
        {
            document.getElementById("NEXT_ENABLED").className="hide";
            document.getElementById("NEXT_DISABLED").className="";
            document.getElementById("PREV_ENABLED").className="hide";
            document.getElementById("PREV_DISABLED").className="";
        }
        else if((current_diff_index == -1) || (current_diff_index == 0) ||
                (diff_array.length == 1 && (! isAlreadyViewed)) )
        {
            document.getElementById("NEXT_ENABLED").className="";
            document.getElementById("NEXT_DISABLED").className="hide";
            document.getElementById("PREV_ENABLED").className="hide";
            document.getElementById("PREV_DISABLED").className="";
        }
        else if(current_diff_index == (diff_array.length-1))
        {
            document.getElementById("NEXT_ENABLED").className="hide";
            document.getElementById("NEXT_DISABLED").className="";
            document.getElementById("PREV_ENABLED").className="";
            document.getElementById("PREV_DISABLED").className="hide";
        }
        else if(current_diff_index < (diff_array.length-1) ||
                current_diff_index > 0)
        {
            document.getElementById("NEXT_ENABLED").className="";
            document.getElementById("NEXT_DISABLED").className="hide";
            document.getElementById("PREV_ENABLED").className="";
            document.getElementById("PREV_DISABLED").className="hide";
        }
        
        // Adjust table cell heights
        adjustTableContentHeights(false);
    }
    else // Assumes that it is SHOW_DIFF_ALONE selection
    {
        document.getElementById('SHOW_ALL_DISPLAY').className="hide";
        document.getElementById('SHOW_DIFF_ALONE_DISPLAY').className="";

        document.getElementById("NEXT_ENABLED").className="hide";
        document.getElementById("NEXT_DISABLED").className="";
        document.getElementById("PREV_ENABLED").className="hide";
        document.getElementById("PREV_DISABLED").className="";

        //document.getElementById("DIFF_NUMBER").value="Total diff lines = "+diff_array.length;
	document.getElementById("DIFF_NUMBER").value="";
	
	// Adjust table cell heights
	adjustTableContentHeights(true);
    }
}

function goToNextDiffLine()
{
    if(isUpCompleted && isDownCompleted)
    {
        document.getElementById("scrolllockcheckbox").checked = true;
        current_diff_index = parseInt(current_diff_index);
        if(current_diff_index != diff_array.length)
        {
            var current_value = diff_array[current_diff_index];
            if(current_diff_index != -1)
            {
                document.getElementById("DIFF1_"+current_value).className = "";
                document.getElementById("DIFF2_"+current_value).className = "";
            }
            current_diff_index++;

            current_value = diff_array[current_diff_index];
            document.getElementById("DIFF1_"+current_value).className = "diffHighlight";
            document.getElementById("DIFF2_"+current_value).className = "diffHighlight";
            var table_row_1 = "DIFF1_"+current_value;
            scrollToView(table_row_1);
        }

        if(diff_array.length == 1)
        {
            document.getElementById("NEXT_ENABLED").className="hide";
            document.getElementById("NEXT_DISABLED").className="";
            document.getElementById("PREV_ENABLED").className="hide";
            document.getElementById("PREV_DISABLED").className="";
            isAlreadyViewed = true;
        }
        else if(current_diff_index < (diff_array.length-1))
        {
            document.getElementById("NEXT_ENABLED").className="";
            document.getElementById("NEXT_DISABLED").className="hide";
            document.getElementById("PREV_ENABLED").className="";
            document.getElementById("PREV_DISABLED").className="hide";
        }
        else if(current_diff_index == (diff_array.length-1))
        {
            document.getElementById("NEXT_ENABLED").className="hide";
            document.getElementById("NEXT_DISABLED").className="";
            document.getElementById("PREV_ENABLED").className="";
            document.getElementById("PREV_DISABLED").className="hide";
        }
        document.getElementById("DIFF_NUMBER").value=I18N.getMsg("js.diffview.goToNextDiffLine.value")+(current_diff_index+1)+I18N.getMsg("js.diffview.goToNextDiffLine.value.1")+diff_array.length;
    }
}

function goToPreviousDiffLine()
{
    if(isUpCompleted && isDownCompleted)
    {
        document.getElementById("scrolllockcheckbox").checked = true;
        current_diff_index = parseInt(current_diff_index);
        if(current_diff_index != 0)
        {
            var current_value = diff_array[current_diff_index];
            if(current_diff_index != -1)
            {
                document.getElementById("DIFF1_"+current_value).className = "";
                document.getElementById("DIFF2_"+current_value).className = "";
            }
            current_diff_index--;

            current_value = diff_array[current_diff_index];
            document.getElementById("DIFF1_"+current_value).className = "diffHighlight";
            document.getElementById("DIFF2_"+current_value).className = "diffHighlight";
            var table_row_1 = "DIFF1_"+current_value;
            scrollToView(table_row_1);
        }

        if((diff_array.length-1) == 1 || current_diff_index == 0)
        {
            document.getElementById("NEXT_ENABLED").className="";
            document.getElementById("NEXT_DISABLED").className="hide";
            document.getElementById("PREV_ENABLED").className="hide";
            document.getElementById("PREV_DISABLED").className="";
        }
        else if(current_diff_index > 0)
        {
            document.getElementById("NEXT_ENABLED").className="";
            document.getElementById("NEXT_DISABLED").className="hide";
            document.getElementById("PREV_ENABLED").className="";
            document.getElementById("PREV_DISABLED").className="hide";
        }
        document.getElementById("DIFF_NUMBER").value=I18N.getMsg("js.diffview.goToNextDiffLine.value")+(current_diff_index+1)+I18N.getMsg("js.diffview.goToNextDiffLine.value.1")+diff_array.length;
    }
}

function scrollToView(id) {
    var el = document.getElementById(id);
    var top = parseInt(findPosY(el));
    var height = el.offsetHeight;
    var docHeight = document.body.clientHeight;
    var scrollTop = document.getElementById("first").scrollTop;
    if (scrollTop - top > 0) {
        scrollUpCnt = top - 170;
        scrollUpIntvl = window.setInterval("scrollUp()", 10);
    } else if (top + 350 + height - scrollTop > docHeight) {
        scrollDownCnt = (top + 350 + height) - docHeight;
        scrollDownIntvl = window.setInterval("scrollDown()", 10);
    }
    else
    {
        scrollUpCnt = top - 170;
        scrollUpIntvl = window.setInterval("scrollUp()", 10);
    }
}

var scrollUpCnt = 0;
var scrollDownCnt = 0;
var isDownCompleted = true;
var isUpCompleted = true;
var prevScrollTop = 0;
var exceedCount = 0;

function scrollDown() {
    isDownCompleted = false; 
    var scrollTop = document.getElementById('first').scrollTop;
    prevScrollTop = (prevScrollTop == 0) ? scrollTop : prevScrollTop;
    //alert("ScrollDown => ST : "+(scrollTop+200)+" <--> SD : "+scrollDownCnt+" <--> PST : "+(prevScrollTop+200)+" <--> EC : "+exceedCount);    
    var clearExecution = false;
    if ((scrollTop+200) < scrollDownCnt) {
        if(prevScrollTop > scrollTop) {
            if(exceedCount == 5) {
                clearExecution = true;
            }
            else {
                exceedCount++;
                document.getElementById('first').scrollTop += 50;
                document.getElementById('second').scrollTop += 50;
            }
        }
        else {
            exceedCount = 0;
            prevScrollTop = scrollTop + 50;
            document.getElementById('first').scrollTop += 50;
            document.getElementById('second').scrollTop += 50;
        }
    }
    else
        clearExecution = true;
    if(clearExecution) {
        scrollDownCnt = 0;
        prevScrollTop = 0;
        exceedCount = 0;
        window.clearInterval(scrollDownIntvl);
        isDownCompleted = true; 
    }
}

function scrollUp() {
    isUpCompleted = false; 
    var scrollTop = document.getElementById('first').scrollTop;
    prevScrollTop = (prevScrollTop == 0) ? scrollTop : prevScrollTop;
    //alert("ScrollUp =>  ST : "+(scrollTop)+" <--> SU : "+scrollUpCnt+" <--> PST : "+(prevScrollTop)+" <--> EC : "+exceedCount);    
    var clearExecution = false;
    scrollUpCnt = (scrollUpCnt < 0) ? 0 : scrollUpCnt;
    if (scrollTop > scrollUpCnt) {
        if(scrollTop > prevScrollTop) {
            if(exceedCount == 5) {
                clearExecution = true;
            }
            else {
                exceedCount++;
                document.getElementById('first').scrollTop -= 50;
                document.getElementById('second').scrollTop -= 50;
            }
        }
        else {
            exceedCount = 0;
            prevScrollTop = scrollTop - 50;
            document.getElementById('first').scrollTop -= 50;
            document.getElementById('second').scrollTop -= 50;
        }
    }
    else
        clearExecution = true;
    if(clearExecution) {
        scrollUpCnt = 0;
        prevScrollTop = 0;
        exceedCount = 0;
        window.clearInterval(scrollUpIntvl);
        isUpCompleted = true; 
    }
}

function adjustTableContentHeights(showdiffalone)
{   
    if(showdiffalone) // Modify DiffAlone content
    {
        firsttable = document.getElementById("FirstTable_DiffAlone");
    	secondtable = document.getElementById("SecondTable_DiffAlone");
    }
    else // Modify ShowAll content
    {
    	var firsttable = document.getElementById("FirstTable_ShowAll");
    	var secondtable = document.getElementById("SecondTable_ShowAll");
    }

    //alert("First Table => Diff Alone Selected: "+showdiffalone+"  <--> Length = "+firstDiffAlone.rows.length);
    if(firsttable != null && secondtable != null)
    {
        var firstRows = firsttable.rows;
        var secondRows = secondtable.rows;

        if(firsttable.offsetHeight != secondtable.offsetHeight)
        {
            for(i=0;i<firstRows.length;i++)
            {
                var firstHeight = firstRows[i].offsetHeight;
                var secondHeight = secondRows[i].offsetHeight;
                //alert("FH : "+firstHeight+"  <-->  SH : "+secondHeight);
                if( firstHeight > secondHeight)
                {
                    secondRows[i].style.height = firstHeight;
                }
                else
                {
                    firstRows[i].style.height = secondHeight;
                }
            }
        }
    }
}

function adjustTableContentHeightsForReport(count)
{   
    for(var changecount=1;changecount<=count;changecount++)
    {
	firsttable = document.getElementById("FirstTable_DiffAlone_"+changecount);
	secondtable = document.getElementById("SecondTable_DiffAlone_"+changecount);

	if(firsttable != null && secondtable != null)
	{
	    var firstRows = firsttable.rows;
	    var secondRows = secondtable.rows;

	    if(firsttable.offsetHeight != secondtable.offsetHeight)
	    {
	        for(i=0;i<firstRows.length;i++)
	        {
	   	    var firstHeight = firstRows[i].offsetHeight;
		    var secondHeight = secondRows[i].offsetHeight;
		    if( firstHeight > secondHeight)
		    {
		        secondRows[i].style.height = firstHeight;
		    }
		    else
		    {
		        firstRows[i].style.height = secondHeight;
		    }
		}
	    }
	}
    }
}
