/* $Id: emailchooser.js,v 1.11 2009/08/05 07:53:40 vasus Exp $ */
function selectEmailRecipients(selectComp)
{
	var options = selectComp.options;
	var len = options.length;
	for(var i=0;i<len;i++)
	{
		options[i].selected = true;
	}
}

function checkAddAction(form)
{
	newaddress = form.NEW_EMAIL_ADDRESS;
	if(validateEmailAddress(newaddress))
	{
		addNewEmailRecipientInSelect(newaddress.value,form.emailSelect,
				form.EMAIL_RECIPIENTS,form.NEW_ADDRESS,form.REMOVED_ADDRESS);
		newaddress.value='';
	}
}

function checkRemoveAction(form)
{
	var selectedOptions = getSelectedItems(form.emailSelect);
	if(selectedOptions == '')
	{
		alert(I18N.getMsg("js.emailchooser.checkRemoveAction.alert"));
	}
	else
	{
		removeEmailRecipientsFromSelect(selectedOptions,form.emailSelect,
				form.NEW_ADDRESS,form.REMOVED_ADDRESS,availableEmails);
	}
}

function addNewEmailRecipientInSelect(newRecipient,emailSelect,EMAIL_RECIPIENTS,NEW_ADDRESS,REMOVED_ADDRESS)
{
	if(newRecipient == 'null')
	{
		return;
	}

	var options = emailSelect.options;

	// checking if email already exists
	var len = options.length;
	for(var i=0;i<len;i++)
	{
		if(newRecipient == options[i].value)
		{
			alert(I18N.getMsg("js.emailchooser.addNewEmailRecipientInSelect.alert.1"));
			return;
		}
	}

	// checking if email exists in the EMAIL_RECIPIENTS option list
	var emailRecipientOptions = EMAIL_RECIPIENTS.options;
	var recipientLen = emailRecipientOptions.length;
	for(var k=0;k<recipientLen;k++)
	{
		if(newRecipient == emailRecipientOptions[k].value)
		{
			alert(I18N.getMsg("js.emailchooser.addNewEmailRecipientInSelect.alert.2"));
			return;
		}
	}

	var newOption = new Option(newRecipient,newRecipient,true);
	// required for IE
	newOption.selected = true;

	// Using new Option() (in a page other than the one in which the select is defined),
	// does not work in IE 6, the browser crashes, hence using the above solution
	// For more details refer http://www.quirksmode.org/js/options.html
	// new Option(newRecipient,newRecipient,true);

	emailRecipientOptions[emailRecipientOptions.length] = newOption;

	var isRemovedOption = false;

	// checking if this new option is a previously removed one
	var removedAddressOptions = REMOVED_ADDRESS.options;
	var removedLen = removedAddressOptions.length;
	for(var m=0;m<removedLen;m++)
	{
		if(removedAddressOptions[m].value == newRecipient)
		{
			removedAddressOptions[m] = null;
			isRemovedOption = true;
			break;
		}
	}

	// only if the option is not a previously removed one
	// it will be considered to be a newly added one and will be 
	// added to the newEmails list
	if(isRemovedOption == false)
	{
		var newOption1 = new Option(newRecipient,newRecipient,true);
		// required for IE
		newOption1.selected = true;

		var newEmailOptions = NEW_ADDRESS.options;
		newEmailOptions[newEmailOptions.length]=newOption1;
	}

}

function getSelectedItems(selectOption)
{
	var selectedOptions = "";

	var options = selectOption.options;
	var len = options.length;
	for(var i=0;i<len;i++)
	{
		if(options[i].selected)
		{
			if(selectedOptions == "")
				selectedOptions = options[i].value;
			else  
				selectedOptions = selectedOptions + "," + options[i].value;
		}
	}

	return selectedOptions;
}

function removeEmailRecipientsFromSelect(emailRecipients,emailSelect,NEW_ADDRESS,REMOVED_ADDRESS,availableEmails)
{
	if(emailRecipients == 'null')
	{
		return;
	}

	var emailRecArray = emailRecipients.split(",");
	var len = emailRecArray.length;
	var options = emailSelect.options;

	var removedAddressOptions = REMOVED_ADDRESS.options;
	var newEmailOptions = NEW_ADDRESS.options;

	for(var i=0;i<len;i++)
	{
		var optionsLen = options.length;
		for(var j=optionsLen-1;j>=0;j--)
		{
			if(options[j].value == emailRecArray[i])
			{
				var newlyAdded = false;
				var alreadyUsed = false;

				// checking if the removed option is a newly added one 
				// if newly added removing from newEmails list also
				for(var k=0;k<newEmailOptions.length;k++)
				{
					if(newEmailOptions[k].value == emailRecArray[i])
					{
						newEmailOptions[k] = null;
						newlyAdded = true;
						break;
					}
				}

				// if not a newly added option then add to the removedEmails list
				// only if the email is not already configured for a schedule
				if(newlyAdded == false)
				{
					var availableEmailsLen = availableEmails.length;
					for(var n=0;n<availableEmailsLen;n++)
					{
						if(availableEmails[n] == options[j].value)
						{
							alert(I18N.getMsg("js.emailchooser.removeEmailRecipientsFromSelect.alert.1") + options[j].value + I18N.getMsg("js.emailchooser.removeEmailRecipientsFromSelect.alert.2"));
							alreadyUsed = true;
							break;
						}
					}

					if(alreadyUsed == false)
					{
						var removedEmailOption = new Option(options[j].text,options[j].value,true);
						// required for IE
						removedEmailOption.selected = true;
						removedAddressOptions[removedAddressOptions.length] = removedEmailOption;
					}
				}

				if(alreadyUsed == false)
				{
					options[j] = null;
				}
			}
		}
	}
}

function validateEmailAddress(ADDRESS)
{
    if(checkIfTextfieldEmpty(ADDRESS,I18N.getMsg("js.emailchooser.validateEmailAddress.alert")))
    {
        return false;
    }
    return checkEmailAddress(ADDRESS.value);
}

/*
 *	This method should be used for validating this email chooser components
 */
function emailChooserValidation(form)
{
	var email_recipients = form.EMAIL_RECIPIENTS;
	if( email_recipients.options.length == 0 )
	{
		alert(I18N.getMsg("js.emailchooser.emailChooserValidation.alert"));
		return false;
	}
	selectEmailRecipients(form.EMAIL_RECIPIENTS);
	return true;
}

